{
myCDRip - Executable for CDDBing/Ripping/Encoding in a single process for myHTPC

Usage
myCDRip -cddrive=[drive number] -cddbchoice -pathtorip [PATH] -format=ogg/mp3/flac -bitrate [BITRATE] -pathtoenc [PATH] -filename [VARNAME]
 
Parameters
----------
-cddrive=
If you have more than one CD Driver you can select it else take the first cd drive
ie : -cddrive=0/1 

-cddbchoice=
if you select this option, when a cddb query returns more than one album, the user can select the choice
if you not select this option, only the first proposal will be selected automaticaly.

-pathtorip=
Path where you want the temporary ripping files will be stocked.

-format=ogg/mp3/flac
select the output audio format (mp3 by default).

-bitrate=
Select the bitrate of the audio format, must be a number.
192 by default

-compression=
Set the compression variable for the ogg vorbis format (must be a real between 0 and 1.0)

-pathtoenc=
Path where you want to stock encoded files.
Check the filename arguments for making directory.

-filename=
This is a string which describe format of outputfile.
It can include name of directory and subdirectory in addition of pathtoenc, it must be enclosed into quote
You can use these variables :
%ARTIST%
%ALBUM%
%GENRE%
%TRACKNB%
%TRACKNAME%
ie : -filename="\%ARTIST%\%ALBUM%\%TRACKNB% - %TRACKNAME%"
will be \TELEPHONE\RAPPELS 2\02 - SUR LA ROUTE"

Procedures
----------
ParseArgs
Check, select and store parameters for this software

QueryCDDB
Query the CDDB with the info CD

SelectCDDB
Proposal a choice if more than one album is find

RipCD
Rip the CD

SetName
Generate name for directories and filename with the parameters

EncodeCD
Encode the rippen data

Close
Terminate the application

History
-------
v0.1 - 22/04/2004
  First writing.
  Define procedures :
  - ParseArgs
  - QueryCDDB
  - SelectCDDB
  - RipCD
  - SetName
  - EncodeCD
  - Close
}
unit Unit1;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, StdCtrls, strutils, CDDBConnect,ExtCtrls, ComCtrls, ACS_FLAC,
  ACS_LAME, ACS_Classes, ACS_Vorbis, ACS_Wave,
  ACS_CDROM, ComObj,Cddb,TypInfo,IniFiles, jpeg, MSXML_TLB,
  XiProgressBar,
  sSkinManager, sCustomLabel, sPanel, sSkinProvider,sSkinProps,
  sButtonControl, sCustomButton,  sEdit, AdvPicture, IEHTTP3, HTMLParser,
  IdHTTP,
  CDEvents, OneInstance, IdComponent, IdTCPConnection, IdTCPClient,
  OleServer, IdBaseComponent,id3v2;

const
  WM_READ = WM_USER + 1024;
  
type
  TForm1 = class(TForm)
    trackList: TListBox;
    audioFormatBox: TComboBox;
    VorbisOut1: TVorbisOut;
    MP3Out1: TMP3Out;
    FLACOut1: TFLACOut;
    Cddb1: TCddb;
    TimerCDDB: TTimer;
    CDIn1: TCDIn;
    XML1: TDOMDocument;
    ProgressBar1: TXiProgressBar;
    sSkinProvider1: TsSkinProvider;
    sSkinManager1: TsSkinManager;
    cddbbtn: TsButton;
    sPanel1: TsPanel;
    ripbtn: TsButton;
    exitbtn: TsButton;
    artist: TsEdit;
    sPanel2: TsPanel;
    sLabel1: TsLabel;
    album: TsEdit;
    category: TsEdit;
    sLabel2: TsLabel;
    sLabel3: TsLabel;
    sPanel3: TsPanel;
    Timer1: TTimer;
    sPanel4: TsPanel;
    slideBtn: TsButton;
    AdvPicture1: TAdvPicture;
    HTMLParser1: THTMLParser;
    IE1: TIEHTTP;
    IdHTTP1: TIdHTTP;
    CDEvents1: TCDEvents;
    OneInstance1: TOneInstance;
    bitrateBox: TComboBox;
    procedure Button1Click(Sender: TObject);
    procedure FormCreate(Sender: TObject);
    procedure riptBtnClick(Sender: TObject);
    procedure refreshBtnClick(Sender: TObject);
    procedure FormKeyDown(Sender: TObject; var Key: Word;
      Shift: TShiftState);

    procedure audioFormatBoxChange(Sender: TObject);

    procedure TimerCDDBTimer(Sender: TObject);
    procedure Cddb1Match(Sender: TObject; Matches: TMatchArray;
      var RightOne: Integer);
    procedure Cddb1StatusMessage(Sender: TObject; Status: String);
    procedure ripBtnClick(Sender: TObject);
    procedure cddbBtnEnter(Sender: TObject);
    procedure cddbBtnExit(Sender: TObject);
    procedure exitBtnExit(Sender: TObject);
    procedure exitBtnEnter(Sender: TObject);
    procedure FormDestroy(Sender: TObject);
    procedure cddbbtnClick(Sender: TObject);
    procedure ripbtnMouseEnter(Sender: TObject);
    procedure ripbtnMouseLeave(Sender: TObject);
    procedure exitbtnClick(Sender: TObject);
    procedure Timer1Timer(Sender: TObject);
    procedure slideBtnClick(Sender: TObject);
    procedure CDEvents1AfterRemove(Sender: TObject;
      FirstDriveLetter: Char);
    procedure CDEvents1AfterArrival(Sender: TObject;
      FirstDriveLetter: Char);
    procedure bitrateBoxChange(Sender: TObject);
    procedure FLACOut1ThreadException(Sender: TComponent; E: Exception);
    procedure MP3Out1ThreadException(Sender: TComponent; E: Exception);
    procedure VorbisOut1ThreadException(Sender: TComponent; E: Exception);
  private
    cddb : boolean;
    auto : boolean; // Set if rip is automatically started
    bitrate : integer;
    pathToEnc : string;
    CDDBChoice : boolean;
    filename : string;
    filenameF : string;
    stopRip : boolean;
    BackgroundFile : string;
    activeColor, inactiveColor : TColor;
    currCover : integer;
    searchString : string;
    streamList : TList;
    logFile : TextFile;
    debug: boolean;
    CDDB_Char : string;
    space_char : string;
    year : string;
    coverName : string;
    function ExtractValue(Param : string): string;
    procedure ReadIniConf; // Procedure for reading conf file (proxy/user/pass etc.)
    procedure RefreshCD();
    procedure ParseArgs(); // Procedure for parsing arguments in command line
    procedure SetBitrate(value : string); // set the bitrate
    procedure SetCompression(value : string); // Set compression for ogg vorbis
    procedure SetAudioFormat(value : string); // Set the audio format
    procedure SetPathToEnc(value : string); // Set the temporaly path to encode
    procedure SetFileName(value : string); // set the filename for encoded file
    procedure Rip1Progress(Sender: TComponent); // Procedure called by ripProgress of composant
    procedure setCDDrive(value : string); // Set the CD Drive (0 for first, 1 for second, etc.)
    procedure CDDBQuery; // Query the CDDB with the Audio CD inside
    procedure WMRead(var msg: TMessage);  message WM_READ;
    procedure GetMyHTPCConf(pathMyHTPC : string); // Get the myHTPC Conf
    function ColorFromBGRStr(B, G, R : string) : TColor;
    procedure showCover(index:integer);
    procedure getCoversList;
    procedure clearCoversList(first : boolean);
    procedure CDrip; // Rip the audio CD
    procedure createLog;
    procedure addLog(messageLog : string);
    procedure closeLog;
    function valideFileName(filename : string):string;
    { Dclarations prives }
  public
    { Dclarations publiques }
  end;

var
  Form1: TForm1;
  myTag: Tid3v2Tag;
  
implementation
uses CdInfo, ShellAPI, selectAlbum;

{$R *.dfm}
procedure TForm1.createLog;
begin
AssignFile(logFile, 'myCDRip.log'); { Fichier slectionn dans la bote de dialogue }
Rewrite(logFile);
end;

procedure TForm1.closeLog;
begin
CloseFile(logFile);
end;

procedure TForm1.addLog(messageLog : string);
begin
if debug then writeln(logFile,messageLog);
end;

procedure TForm1.clearCoversList(first : boolean);
var
compteur : integer;
finalStream : TMemoryStream;
begin
slideBtn.Caption:='Slide';
for compteur:=0 to streamList.Count-1 do
  begin
  TMEmoryStream(streamList[compteur]).Destroy;
  end;
streamList.Clear;
if first then begin
  if fileexists('NOCOVER.jpg') then
    begin
      finalStream:=TMemoryStream.Create;
      finalStream.LoadFromFile('NOCOVER.jpg');
      streamlist.Add(finalStream);
    end;
  end;
end;

procedure TForm1.showCover(index:integer);
begin
  try
      slideBtn.Caption:='Slide '+inttostr(index+1)+' of '+inttostr(streamlist.Count);
//      idHTTP1.Get(listeCovers[index],stream);
//      AdvPicture1.Picture.LoadFromStream(stream);
      AdvPicture1.Picture.LoadFromStream(streamlist[index]);
  finally
  end;
end;

procedure TForm1.getCoversList;
var
oMsg : IXMLHTTPRequest;
responseDoc : IXMLDOMDocument;
doc : IXMLDOMDocument;
//strxml : string;
//ElemList: IXMLDOMNodeList;
NodeList: IXMLDOMNodeList;
//Node: IXMLDOMNode;
compteur : integer;
fichier,temp : string;
//tempList : TStringList;
tempStream, finalstream :TMemoryStream;
begin
//  listeCovers.Clear;
  tempStream:=TMemoryStream.Create;
//  ie1.RequestMethod:='GET';
//  ie1.ExecuteURL(AnsiReplaceText(searchString,'#SEARCH#',album.Text+' '+artist.Text));
//  memo2.Lines.Assign(ie1.result_sl);
  doc:= CoDomDocument.Create;
  // 1) create the document
  responseDoc:= CoDomDocument.Create;
  // 2) create the HTTP interface
  oMsg:= CoXMLHttpRequest.Create;
  try
{ add the no cover picture }
//  tempList:=TstringList.Create;
//  tempList.assign(ie1.result_sl);
//  doc.loadXML(ie1.result_sl.GetText);
  temp:=AnsiReplaceText(searchString,'#SEARCH#',album.Text+' '+artist.Text);
  temp:=AnsiReplaceText(temp,' ','%20');
  doc.loadXML(idHTTP1.Get(temp));
  if idHTTP1.ResponseCode=200 then begin
  NodeList := Doc.documentElement.selectNodes('//Details/ImageUrlLarge');
  sPanel3.Caption:='Check cover list';
  sPanel3.repaint;
  for compteur:=0 to NodeList.length-1 do
    begin
    tempStream.Clear;
      sPanel3.Caption:='Validate cover '+inttostr(compteur+1)+' of '+inttostr(NodeList.length);
      sPanel3.repaint;
      fichier:=Nodelist.item[compteur].text;
      idHTTP1.Get(fichier, tempStream);
      if (idHTTP1.Response.ContentType='image/jpeg') then
        begin
        finalStream:=TMemoryStream.Create;
        finalStream.LoadFromStream(tempStream);
        streamlist.Add(finalStream);
        end;
//        listeCovers.Add(fichier);
    end;
   end;
  if streamlist.Count>2 then
   sPanel3.Caption:=inttostr(streamlist.Count-1)+' covers found !';
  if streamlist.Count=2 then
   sPanel3.Caption:=inttostr(streamlist.Count-1)+' cover found !';
  if streamlist.Count=1 then
   sPanel3.Caption:='No covers was found !';
   showcover(streamlist.Count-1);
//  sPanel3.repaint;
  finally
    doc:= nil;
    responseDoc:= nil;
    oMsg:= nil;
//    tempList.destroy;
    tempStream.Destroy;
  end;
end;

function TForm1.ColorFromBGRStr(B, G, R : string) : TColor;
begin
  Result := StrToInt(Format('$00%2.2x%2.2x%2.2x',
                            [StrToInt(B),
                             StrToInt(G),
                             StrToInt(R)]));
end;

{*-
Set the path for the ripped files

@param value  string value of the  path
-}
procedure TForm1.SetPathToEnc(value : string);
begin
pathToEnc:=value;
end;

procedure TForm1.SetCompression(value : string);
var
comp : single;
begin
comp:=strtofloat(value);
if comp>10 then comp:=0.2;
VorbisOut1.compression:=comp;
end;

{*-
Set the bitrate of the compressed audio format

@param value  string value of the bitrate selected
-}
procedure TForm1.SetBitrate(value : string);
begin
value:='br'+value;
// Select MP3 Bitrate
bitrate:=GetEnumValue(TypeInfo(TMP3BitRate),value);
if bitrate<>-1 then MP3Out1.BitRate:=TMP3BitRate(bitrate);
end;

{*-
Set the format of the compressed audio format.
variable audioFormat 0 = MP3, 1 = OGG, 2 = FLAC

@param value  string value of the format selected
-}
procedure TForm1.SetAudioFormat(value : string);
begin
if strlower(PChar(value))='mp3' then audioFormatBox.ItemIndex:=0;
if strlower(PChar(value))='ogg' then audioFormatBox.ItemIndex:=1;
if strlower(PChar(value))='flac' then audioFormatBox.ItemIndex:=2;
//audioFormatBoxChange(nil);
end;

{*-
Extract the value of a parameter in a command line
The param must be a couple of var=value, if value is a long file name, it must be enclosed by double-quote

@param Param string which contain the couple var=value
@return the value extracted of the variable
-}
function TForm1.ExtractValue(Param : string): string;
Var
value : PChar;
returnValue : string;
begin
value:=AnsiStrPos(PChar(Param),'=');
inc(value);
  if value<>nil then
    begin
    SetString(returnValue,value,strlen(value));
    result:=returnValue;
    end;
end;

{*-----------------------------------------------------------------
Parse the arguments
-------------------------------------------------------------------}
procedure TForm1.ParseArgs;
var
counter : integer;
arg : string;
begin
for counter:=1 to ParamCount do
  begin
  if AnsiPos('=',ParamStr(counter))=0 then
    begin
    arg:=ParamStr(counter);
    end
  else
    arg:=AnsiLeftStr(ParamStr(counter),strlen(PChar(ParamStr(counter)))-strlen(StrScan(PChar(ParamStr(counter)),'=')));
  if lowercase(arg)='-cddbchoice' then cddbchoice:=true;
  if lowercase(arg)='-bitrate' then setBitrate(ExtractValue(ParamStr(counter)));
  if lowercase(arg)='-compression' then setCompression(ExtractValue(ParamStr(counter)));
  if lowercase(arg)='-pathtoenc' then setPathtoEnc(ExtractValue(ParamStr(counter)));
  if lowercase(arg)='-filename' then setFileName(ExtractValue(ParamStr(counter)));
  if lowercase(arg)='-format' then SetAudioFormat(ExtractValue(ParamStr(counter)));
  if lowercase(arg)='-cddrive' then setCDdrive(ExtractValue(ParamStr(counter)));
  if lowercase(arg)='-auto' then auto:=true;
  if lowercase(arg)='-debug' then debug:=true else debug:=false;
  end;
  // After we put the correct info in bitratebox
    case audioFormatBox.ItemIndex of
      0 : begin;
          bitratebox.ItemIndex:=ord(mp3out1.bitrate);
          end;
      1 : begin;
          bitratebox.ItemIndex:=round(vorbisout1.compression - int(vorbisout1.compression));
          end;
    end;
end;

procedure TForm1.SetCDdrive(value:string);
begin
  if strtoint(value)<=CDIn1.DrivesCount then
    begin;
      CDIn1.CurrentDrive:=strtoint(value);
      CDIn1.Reset;
      AddLog('SetCDrive : Select CDRip drive '+CDIn1.DriveName);
      cddb1.ChangeActiveDrive(CDIn1.CurrentDrive);
      AddLog('SetCDrive : Select CDDB drive '+CDDB1.CdRoms.cdrom[CDDB1.GetActiveDrive].ProductId);
    end;
    // Refresh the tracks from current CD Drive
//refreshCD;
end;
{*-----------------------------------------------------------------
Set the filename of the encoded file

@param Param string which contain the couple var=value
-------------------------------------------------------------------}
procedure TForm1.SetFileName(value:string);
begin
filename:=value;
end;

procedure TForm1.Button1Click(Sender: TObject);
begin
CDDBQuery;
end;

procedure TForm1.FormCreate(Sender: TObject);
var
//  i : integer;
  HTaskbar : HWND;
//  OldVal : LongInt;
  rcWork: TRect;
begin
 TRY
  myTag := Tid3v2tag.create;
  createLog;
  debug:=true;
  AddLog('FormCreate started');
//  ShowCursor(False);
  CDDb:=false;
//  listeCovers:=TStringList.Create;
  streamlist:=Tlist.Create;
  currCover:=0;
  FlacOut1.OnProgress:=Rip1Progress;
  MP3Out1.OnProgress:=Rip1Progress;
  VorbisOut1.OnProgress:=Rip1Progress;
 //Find handle of TASKBAR
   HTaskBar:=FindWindow('Shell_TrayWnd',nil);
 //Disable the taskbar
//   EnableWindow(HTaskBar,False);
 //Hide the taskbar
//   ShowWindow(HTaskbar,SW_HIDE);
  rcWork.Top:=0;
  rcWork.Left:=0;
  rcWork.Bottom:=GetSystemMetrics(SM_CYSCREEN);
  rcWork.Right:=GetSystemMetrics(SM_CXSCREEN);
  SystemParametersInfo (SPI_SETWORKAREA, 0, @rcWork, SPIF_SENDCHANGE);
  AdvPicture1.Picture.LoadFromFile('NOCOVER.jpg');
  advPicture1.Repaint;
FINALLY
  ReadIniConf;
  stopRip:=false;
  auto := false;
  cddbchoice:=false;
  // Define a default audio format
  audioFormatBox.ItemIndex:=0;
  // Define a default filename
  pathToEnc:='.\';
  fileName:='%ARTIST%\%ALBUM%\%TRACKNB% - %TRACKNAME%';
  // TAKE THE NUMBER OR CD DRIVE AND SHOW IN THE LISTBOX
  CDDB1.ChangeActiveDrive(0);
  AddLog('FormCreate : CDRip drive '+CDIn1.DriveName);
  AddLog('FormCreate : CDDB drive '+CDDB1.CdRoms.cdrom[CDDB1.GetActiveDrive].ProductId);
  // Parse The arguments from command line
  debug:=false;
  ParseArgs;
  // Refresh the tracks from current CD Drive
  refreshCD;
  //
  clearCoversList(true);
  // CDDB Query
  CDDBQuery;
  //
  audioFormatBoxChange(Sender);
  AddLog('FormCreate finished');
//  sSkinManager1.Active:=true;
//  cddbbtn.SetFocus;
end;
end;
// Check if filename is valid
function TForm1.valideFileName(filename : string) : string;
begin
if space_char<>'' then filename:=AnsiReplaceStr(filename,' ',space_Char);
filename:=AnsiReplaceStr(filename,'<',CDDB_Char);
filename:=AnsiReplaceStr(filename,'>',CDDB_Char);
filename:=AnsiReplaceStr(filename,':',CDDB_Char);
filename:=AnsiReplaceStr(filename,'"',CDDB_Char);
filename:=AnsiReplaceStr(filename,'/',CDDB_Char);
filename:=AnsiReplaceStr(filename,'\',CDDB_Char);
filename:=AnsiReplaceStr(filename,'|',CDDB_Char);
result:=filename;
end;

// RIP & ENCODE THE CD
procedure TForm1.CDrip;
var
Compteur,tempInt : integer;
fileOut : string;
//startTrack,endTrack: integer;
fileExt : string;
tempVCL : TACSFileOut;
tempTrackNb : string;
finalPath : string;
PicStream: TMemoryStream;
begin
AddLog('CDrip : Starting');
AddLog('CDRip : audioFormat '+audioFormatBox.Items[audioFormatBox.ItemIndex]);
AddLog('CDRip : bitrate '+bitrateBox.Items[bitrateBox.ItemIndex]);
if ((CDIn1.DiscInfo=cdiDiscMixed) or (CDIn1.DiscInfo=cdiDiscAudio)) then
begin
  AddLog('CDrip : DiscInfo OK cdiDiscMixed or cdiDiscAudio');
  case audioFormatBox.ItemIndex of
    0 : begin;fileExt:='.mp3';tempVCL:=MP3Out1;end;
    1 : begin;fileExt:='.ogg';tempVCL:=VorbisOut1;end;
    2 : begin;fileExt:='.flac';tempVCL:=FlacOut1;end;
  end;
  ripBtn.Enabled:=false;
  cddbBtn.Enabled:=false;
  audioFormatBox.Enabled:=false;
  bitrateBox.Enabled:=false;
  tracklist.Enabled:=true;
  exitbtn.SetFocus;
  // Check if directory exist
  finalPath := extractfilepath(pathToEnc+filenameF);
  AddLog('CDrip : Final Path : '+finalPath);
  if not DirectoryExists(finalPath) then
   begin
      ForceDirectories(finalPath);
    end;
  advPicture1.Picture.SaveToFile(finalPath+coverName);
  AddLog('CDrip : Save Picture : '+finalPath+coverName);
  AddLog('CDrip : Process '+inttostr(trackList.Items.Count-1)+' tracks');
  for compteur:=0 to trackList.Items.Count-1 do
    begin
      AddLog('CDrip : Process track number '+inttostr(compteur));
      trackList.ItemIndex:=compteur;
      if stopRip then exit;
      tempTrackNb:='';
      if compteur<9 then tempTrackNb:='0';
      CDIn1.StartTrack:=compteur+1;
      CDIn1.EndTrack:=compteur+1;
      tempTrackNb:=tempTrackNb+inttostr(compteur+1);
      fileOut:=pathToEnc+filenameF;
      fileOut:=AnsiReplaceText(fileOut,'%TRACKNB%',tempTrackNb);
      fileOut:=AnsiReplaceText(fileOut,'%TRACKNAME%',valideFileName(trackList.Items[compteur]));
      fileOut:=fileOut+fileExt;
      AddLog('CDrip : track name '+fileOut);
      sPanel3.Caption:='RIP Track N'+inttostr(compteur+1)+' - '+fileOut;
      case audioFormatBox.ItemIndex of
        0 : begin;
            MP3Out1.id3TagAlbum:=album.text;
            mp3out1.Id3TagArtist:=artist.text;
            mp3out1.Id3TagTitle:=trackList.Items[compteur];
            mp3out1.Id3TagTrack:=tempTrackNb;
            mp3out1.Id3TagYear:=year;
            end;
        1 : begin;
            VorbisOut1.Comments.Add('ARTIST='+artist.Text);
            VorbisOut1.Comments.Add('ALBUM='+ALBUM.Text);
            VorbisOut1.Comments.Add('TITLE='+trackList.Items[compteur]);
            end;
      end;
      tempVCL.FileName:=fileOut;
      AddLog('CDrip : CDRip drive '+CDIn1.DriveName);
      AddLog('CDrip : CDDB drive '+CDDB1.CdRoms.cdrom[CDDB1.GetActiveDrive].ProductId);
      addLog('CDrip : Start resetting CD drive');
      CDIn1.reset;
      addLog('CDrip : Finished resetting CD drive');
      addLog('CDrip : start ripping');
      tempVCL.Run;
      While (tempVCL.Status <> tosidle) and (stopRip=false) do
      begin
        Application.ProcessMessages;
        if stopRip then
          begin
          tempVCL.Stop;
          AddLog('CDrip : Abort ripping');
          end;
      end;
      if (audioFormatBox.ItemIndex=0) and (stopRip<>true) then
        begin
          tempInt := myTag.loadFromFile(fileOut, 0);
          myTag.setAsciiText('TIT2', trackList.Items[compteur]); //Set Song Title
          myTag.setAsciiText('TPE1', artist.text); //Set Artist Name
          myTag.setAsciiText('TALB', album.text); //Set Album Name
          myTag.setAsciiText('TYER', year); //Set Release Year
          myTag.setAsciiText('TCON', category.text); //Set Genre
          myTag.setAsciiText('TRCK', tempTrackNb); //Set Track #
{          myCOMM.encoding := etASCII;
          myCOMM.language := 'ENG';
          myCOMM.description := '';
          myCOMM.body := ID3comment.text;
          myTag.setCOMM(myCOMM, myCOMM.description);    }
          myTag.saveToFile;
        end;
    end;
  ripBtn.Enabled:=true;
  cddbBtn.Enabled:=true;
  audioFormatBox.Enabled:=true;
  bitrateBox.Enabled:=true;
  tracklist.Enabled:=false;
  addLog('CDrip : ripping done');
  sPanel3.Caption:='Rip done !';
  if auto then close;
end;
end;

procedure TForm1.CDDBQuery;
var
  Match : TMatches;
begin
  AddLog('CDDBQuery : Starting');
  AddLog('CDDBQuery : CDRip drive '+CDIn1.DriveName);
  AddLog('CDDBQuery : CDDB drive '+CDDB1.CdRoms.cdrom[CDDB1.GetActiveDrive].ProductId);
   // If CD Drive is ready
   CDDB1.RefreshDrives;
   if ((CDIn1.DiscInfo=cdiDiscMixed) or (CDIn1.DiscInfo=cdiDiscAudio)) then
   try
     AddLog('CDDBQuery : DiscInfo OK cdiDiscMixed or cdiDiscAudio');
     // Check local CDDB
     Cddb1.IndexLocalCDDB;
     Match := Cddb1.FindMatchesFromLocalCDDB;
     AddLog('CDDBQuery : DiscID '+Match[0].DiscID);
     AddLog('Query local CDDB');
      if Match[0].DiscID <> '' then
         if Cddb1.ReadInfoFromLocalCDDB >= 0 then
          begin
            Cddb1StatusMessage(Cddb1,'LocalOK');
            AddLog('CDDBQuery : Local CDDB OK');
            exit;
          end;
      AddLog('CDDBQuery : No local CDDB');
      // Query the internet CDDB
      Cddb1.ServerAdditionalAddr := '/~cddb/cddb.cgi';
      Cddb1.ServerType := HTTP;
      Cddb1.ServerPort := '80';
      AddLog('CDDBQuery : Query internet CDDB');
      Cddb1.http_query;
      TimerCDDB.Interval := 15000;
      TimerCDDB.Enabled := True;
   except
      on e:exception do
        begin
        AddLog('CDDBQuery : unknown CD / CDDB Error');
        Application.messagebox('unknown CD / CDDB Error','Error');
        end;
   end;
end;

procedure TForm1.riptBtnClick(Sender: TObject);
begin
CDRip;
end;

// Refresh the current CD
procedure TForm1.RefreshCD;
var
  i : Integer;
begin
  trackList.Items.Clear;
  artist.Text:='';
  album.Text:='';
  category.Text:='';
  CDIn1.Reset;
  if ((CDIn1.DiscInfo<>cdiDiscMixed) and (CDIn1.DiscInfo<>cdiDiscAudio)) then
    CDIn1.Eject
  else
    begin
      for i := 1 to CDIn1.TracksCount do
        begin
          trackList.Items.Add('Track '+inttostr(i));
        end;
      if trackList.Items.Count > 0 then trackList.ItemIndex := 0;
    end;
end;

procedure TForm1.refreshBtnClick(Sender: TObject);
begin
RefreshCD;
end;

procedure TForm1.FormKeyDown(Sender: TObject; var Key: Word;
  Shift: TShiftState);
  var
  handle : THandle;
begin
if ((key=VK_F4) and (ssAlt in shift)) or (key=VK_ESCAPE) then
  begin
    stopRip:=true;
    close;
  end;
if (key=VK_BACK) then
  begin
      Handle := FindWindow(nil,PChar('myHTPC'));
      If Handle <> 0 Then BringWindowToTop(Handle);
  end;
end;

procedure TForm1.audioFormatBoxChange(Sender: TObject);
var
compteur : integer;
//compteur2 : single;
begin
// Fill the bitrate with appropriate value
bitratebox.Clear;
case audioFormatBox.ItemIndex of
  0 : begin;
      for compteur:=0 to 17 do
        begin
          bitratebox.Items.Add(GetEnumName(TypeInfo(TMP3BitRate),compteur));
        end;
      // Put the correct bitrate index in the listBox
      bitrateBox.ItemIndex:=ord(mp3out1.BitRate);
      end;
  1 : begin;
      for compteur:=0 to 9 do
        begin
          bitratebox.Items.Add(floattostr(frac(compteur / 10)));
        end;
        bitratebox.Items.Add('1.0');
      // Put the correct bitrate index in the listBox
      bitrateBox.ItemIndex:=round(vorbisout1.compression*10);
      end;
  end;
end;

procedure TForm1.TimerCDDBTimer(Sender: TObject);
begin
// No answers from CDDB
TimerCDDB.Enabled := False;
Cddb1.http_Abort;
end;

procedure TForm1.Cddb1Match(Sender: TObject; Matches: TMatchArray;
  var RightOne: Integer);
var
  i : integer;
begin
     TimerCDDB.Enabled := False;
     RightOne := 0;
     for i := 0 to 99 do
      if Matches[i] = '' then break;
     if i > 1 then begin
     // If more than one album has been found, popup the choice and wait for the answer
  if cddbchoice then
    begin
      try
      Application.CreateForm(TselectAlbumFrm, selectAlbumFrm);
      selectAlbumFrm.Font:=form1.Font;
        for i := 0 to 99 do
          begin
          if Matches[i] = '' then break
            else
            begin
              selectAlbumFrm.ListBox1.Items.Add(Matches[i]);
              selectAlbumFrm.ListBox1.ItemIndex := 0;
            end;
          end;
          selectAlbumFrm.ShowModal;
          RightOne := selectAlbumFrm.ListBox1.ItemIndex;
     finally
        selectAlbumFrm.close;
     end;
     end
  else
     RightOne := 0;
  end; // if i> 1
     PostMessage(self.Handle, WM_READ, Integer(Sender), 0);
end;

procedure TForm1.WMRead(var msg: TMessage);
var
   DaCDDB: TCddb;
begin
  DaCDDB := TCddb(msg.WParam);
    if (DaCDDB.State = CS_MATCH) or (DaCDDB.State = CS_MULTIMATCH) then
    begin
      DaCDDB.http_read;
    end;
end;

procedure TForm1.Cddb1StatusMessage(Sender: TObject; Status: String);
var
   i : integer;
begin
// DEBUG
//showmessage(status);
  if TCddb(sender).State = CS_HTTPERROR then begin
    sPanel3.Caption:=('Not Connected');
    CDDB :=true;
    end;
  if TCddb(sender).State = CS_NOMATCH then begin
      sPanel3.Caption:=('unknown CD Audio');
  end;

// Take the data found by CDDB query and paste them to the list of track
// Also show the artist/album/category
  if ((TCddb(sender).State = CS_READSUCCESS) and (status='Entry read')) or (Status = 'LocalOK') then begin
     TCddb(sender).ParseEntry;
     album.text := TCddb(sender).CDInfo.Title;
     Artist.text := TCddb(sender).CDInfo.Artist;
     category.Text:= TCddb(sender).CDInfo.Category;
     year:=TCddb(sender).cdinfo.Year;
     album.Repaint;
     artist.Repaint;
     category.Repaint;
     trackList.Items.beginUpdate;
     for i := 1 to CDIn1.TracksCount do begin
         trackList.Items[i - 1] := TCddb(sender).CDInfo.Tracks[i-1];
         end;
     trackList.Items.EndUpdate;
  // ICI SAUVEGARDE CDDB
     Cddb1.SaveInfoToLocalCDDB;
    // Subst the variable filename by info from album
    filenameF:=AnsiReplaceText(filename,'%ARTIST%',valideFileName(artist.Text));
    filenameF:=AnsiReplaceText(filenameF,'%ALBUM%',valideFileName(album.Text));
    filenameF:=AnsiReplaceText(filenameF,'%GENRE%',valideFileName(category.Text));
    // Show the dir destination
    CDDB := true;
    getCoversList;
    sPanel3.Caption:='Destination : '+PathToEnc+extractfilepath(filenameF);
    end;
end;

procedure TForm1.Rip1Progress(Sender: TComponent);
begin
Progressbar1.Position:=TACSOutput(Sender).Progress;
//progressbar1.Refresh;
end;


procedure TForm1.ReadIniConf;
var
iniFile : TIniFile;
path,temp : string;
monitor : integer;
begin
iniFile := TIniFile.Create( ChangeFileExt( Application.ExeName, '.INI' ) );
try
  CDDB1.ProxyAddress := iniFile.ReadString( 'PROXY', 'ProxyIP', '' );
  CDDB1.ProxyPort := iniFile.ReadString( 'PROXY', 'ProxyPort', '' );
  CDDB1.ProxyUsername := iniFile.ReadString( 'PROXY', 'ProxyUser', '' );
  CDDB1.ProxyPassword := iniFile.ReadString( 'PROXY', 'ProxyPass', '' );
  idHTTP1.ProxyParams.ProxyPassword:=CDDB1.ProxyPassword;
  if CDDB1.ProxyPort<>'' then
  idHTTP1.ProxyParams.ProxyPort:=strtoint(CDDB1.ProxyPort);
  idHTTP1.ProxyParams.ProxyServer:=CDDB1.ProxyAddress;
  idHTTP1.ProxyParams.ProxyUsername:=CDDB1.ProxyUsername;
  path:=iniFile.readString('CONF','myHTPC','');
  if ((path<>'') and (DirectoryExists(path))) then GetMyHTPCConf(path);
  path:=iniFile.ReadString('CONF','localCDDB','');
  if (path<>'') then
    begin
     if not DirectoryExists(path) then ForceDirectories(path);
     CDDB1.LocalCDDBPath:=path;
    end;
  temp:=iniFile.ReadString('CONF','Background','');
  if temp<>'' then BackgroundFile:=temp;
  if FileExists(BackgroundFile) then
  begin
      // SkinSections and PropNames are defined in sSkinProps.pas unit
    sSkinManager1.ChangeImageInSkin(normalForm, PatternFile, BackgroundFile);
    sSkinManager1.ChangeImageInSkin(normalForm, HotPatternFile, BackgroundFile);
    // Update of all controls
  end;
   searchString:= inifile.ReadString('CONF','search','http://xml.amazon.com/onca/xml3?t=webservices-20&dev-t=amznRss&KeywordSearch=#SEARCH#&mode=music&bcm=&type=lite&page=1&ct=text/xml&f=xml&locale=uk');
   CDDB_char := iniFile.ReadString('CONF','CDDB_Char','-');
   space_char := iniFile.ReadString('CONF','space_char','');
   coverName := iniFile.ReadString('CONF','cover_name','cover.jpg');
   // TEST MULTIMONITOR
   monitor:=inifile.ReadInteger('CONF','Monitor',0);
   self.MakeFullyVisible(Screen.Monitors[monitor]);
   // FIN TEST MULTIMONITOR
finally
  iniFile.Destroy;
end;
end;

// Get the myHTPC Conf
procedure TForm1.GetMyHTPCConf(pathMyHTPC : string);
var
//test : string;
//ElemList: IXMLDOMNodeList;
NodeList: IXMLDOMNodeList;
//Node: IXMLDOMNode;
Doc: IXMLDOMDocument;
//attrib : IXMLDOMNamedNodeMap;
//i, count : integer;
transparency, hotTransparency : single;
//fColor : string;

begin
// Get the path
if pathMyHTPC[strlen(PChar(pathMyHTPC))]<>'\' then pathMyHTPC:=pathMyHTPC+'\';
// Load the XML file
Doc := CreateOleObject('Microsoft.XMLDOM') as IXMLDomDocument;
Doc.load(pathMyHTPC+'myHTPC.cfg');
NodeList := Doc.documentElement.selectNodes('//Display/DefaultTheme');
// Get the Background picture
if nodeList<>nil then
  BackgroundFile := NodeList.item[0].attributes.getNamedItem('BackgroundFile').nodeValue;
if BackgroundFile='' then BackgroundFile:=pathMyHTPC+'images\background.jpg';
//if FileExists(BackgroundFile) then image1.Picture.LoadFromFile(BackgroundFile);
// Get info for captions
NodeList := Doc.documentElement.selectNodes('//Display/DefaultTheme/CaptionFont');
if nodeList<>nil then
  begin
    form1.Font.Name := NodeList.item[0].attributes.getNamedItem('Name').nodeValue;
    form1.Font.Size := NodeList.item[0].attributes.getNamedItem('Size').nodeValue;
//    selectAlbumFrm.Font.Name := NodeList.item[0].attributes.getNamedItem('Name').nodeValue;
//    selectAlbumFrm.Font.Size := NodeList.item[0].attributes.getNamedItem('Size').nodeValue;
  end;
// Get info for captions
NodeList := Doc.documentElement.selectNodes('//Display/DefaultTheme/MainMenuFont');
if nodeList<>nil then
  begin
    exitBtn.Font.Name := NodeList.item[0].attributes.getNamedItem('Name').nodeValue;
    exitBtn.Font.Size := NodeList.item[0].attributes.getNamedItem('Size').nodeValue;
    ripBtn.Font.Name := NodeList.item[0].attributes.getNamedItem('Name').nodeValue;
    ripBtn.Font.Size := NodeList.item[0].attributes.getNamedItem('Size').nodeValue;
    CddbBtn.Font.Name := NodeList.item[0].attributes.getNamedItem('Name').nodeValue;
    CddbBtn.Font.Size := NodeList.item[0].attributes.getNamedItem('Size').nodeValue;
    sPanel3.Font.Size := 18;
    sPanel3.Font.Name := NodeList.item[0].attributes.getNamedItem('Name').nodeValue;
    slideBtn.Font.Name := NodeList.item[0].attributes.getNamedItem('Name').nodeValue;
    slideBtn.Font.Size := NodeList.item[0].attributes.getNamedItem('Size').nodeValue;
  end;

NodeList := Doc.documentElement.selectNodes('//Display/DefaultTheme/MainMenuFont/FontColor');
if nodeList<>nil then
  begin
    exitBtn.Font.Color:=Form1.ColorFromBGRStr(NodeList.item[0].attributes.getNamedItem('B').nodeValue,NodeList.item[0].attributes.getNamedItem('G').nodeValue,NodeList.item[0].attributes.getNamedItem('R').nodeValue);
    ripBtn.Font.Color:=Form1.ColorFromBGRStr(NodeList.item[0].attributes.getNamedItem('B').nodeValue,NodeList.item[0].attributes.getNamedItem('G').nodeValue,NodeList.item[0].attributes.getNamedItem('R').nodeValue);
    CddbBtn.Font.Color:=Form1.ColorFromBGRStr(NodeList.item[0].attributes.getNamedItem('B').nodeValue,NodeList.item[0].attributes.getNamedItem('G').nodeValue,NodeList.item[0].attributes.getNamedItem('R').nodeValue);
    slideBtn.Font.Color:=Form1.ColorFromBGRStr(NodeList.item[0].attributes.getNamedItem('B').nodeValue,NodeList.item[0].attributes.getNamedItem('G').nodeValue,NodeList.item[0].attributes.getNamedItem('R').nodeValue);
  end;
// Get the font color
NodeList := Doc.documentElement.selectNodes('//Display/DefaultTheme/MainMenuFont/FontColor');
if nodeList<>nil then
  begin
//  form1.Font.Color:=Form1.ColorFromBGRStr(NodeList.item[0].attributes.getNamedItem('B').nodeValue,NodeList.item[0].attributes.getNamedItem('G').nodeValue,NodeList.item[0].attributes.getNamedItem('R').nodeValue);
  end;
// Frame Color for button
NodeList := Doc.documentElement.selectNodes('//Display/DefaultTheme/FrameColor');
if nodeList<>nil then
  begin
    inactiveColor:=ColorFromBGRStr(NodeList.item[0].attributes.getNamedItem('B').nodeValue,NodeList.item[0].attributes.getNamedItem('G').nodeValue,NodeList.item[0].attributes.getNamedItem('R').nodeValue);
//    transparency:=100-((strtoint(NodeList.item[0].attributes.getNamedItem('A').nodeValue)/ 255)*100);
  end;
NodeList := Doc.documentElement.selectNodes('//Display/DefaultTheme/SelectedFrameColor');
if nodeList<>nil then
  begin
  activeColor:=Form1.ColorFromBGRStr(NodeList.item[0].attributes.getNamedItem('B').nodeValue,NodeList.item[0].attributes.getNamedItem('G').nodeValue,NodeList.item[0].attributes.getNamedItem('R').nodeValue);
//  Hottransparency:=100-((strtoint(NodeList.item[0].attributes.getNamedItem('A').nodeValue) div 255)*100);
  end;

RipBtn.sStyle.Painting.Color:=inactiveColor;
RipBtn.sStyle.HotStyle.HotPainting.Color:=activecolor;
//RipBtn.sStyle.Painting.Transparency:=round(transparency);
//RipBtn.sStyle.HotStyle.HotPainting.Transparency:=round(Hottransparency);

cddbBtn.sStyle.Painting.Color:=inactiveColor;
cddbBtn.sStyle.HotStyle.HotPainting.Color:=activecolor;
//cddbBtn.sStyle.Painting.Transparency:=round(transparency);
//cddbBtn.sStyle.HotStyle.HotPainting.Transparency:=round(Hottransparency);

exitBtn.sStyle.Painting.Color:=inactiveColor;
exitBtn.sStyle.HotStyle.HotPainting.Color:=activecolor;
//exitBtn.sStyle.Painting.Transparency:=round(transparency);
//exitBtn.sStyle.HotStyle.HotPainting.Transparency:=round(Hottransparency);

slideBtn.sStyle.Painting.Color:=inactiveColor;
slideBtn.sStyle.HotStyle.HotPainting.Color:=activecolor;
//slideBtn.sStyle.Painting.Transparency:=round(transparency);
//slideBtn.sStyle.HotStyle.HotPainting.Transparency:=round(Hottransparency);

ssKinManager1.UpdateSkin;
{ We need :
			<DefaultTheme BackgroundColor="" BackgroundFile="">
				<TitleFont Name="Arial Black" Size="30" Style="">
					<FontColor A="255" R="255" G="255" B="255"/>
				</TitleFont>
				<SubTitleFont Name="Arial" Size="20" Style="">
					<FontColor A="255" R="255" G="255" B="255"/>
				</SubTitleFont>
				<FooterFont Name="Arial" Size="12" Style="">
					<FontColor A="255" R="255" G="255" B="255"/>
				</FooterFont>
				<MainMenuFont Name="Arial Black" Size="20" Style="">
					<FontColor A="255" R="255" G="255" B="255"/>
				</MainMenuFont>
				<SubMenuFont Name="Arial Black" Size="18" Style="">
					<FontColor A="255" R="255" G="255" B="255"/>
				</SubMenuFont>
				<CaptionFont Name="Arial" Size="12" Style="">
					<FontColor A="255" R="255" G="255" B="255"/>
				</CaptionFont>
				<FrameColor A="127" R="255" G="255" B="255"/>
				<SelectedFrameColor A="204" R="0" G="128" B="0"/>
			</DefaultTheme>
}
end;

procedure TForm1.ripBtnClick(Sender: TObject);
begin
CDrip;
end;

procedure TForm1.cddbBtnEnter(Sender: TObject);
begin
//cddbBtn.ButtonColor:=activeColor;
end;

procedure TForm1.cddbBtnExit(Sender: TObject);
begin
//cddbBtn.ButtonColor:=inactiveColor;
end;

procedure TForm1.exitBtnExit(Sender: TObject);
begin
exitBtn.sStyle.HotStyle.HotPainting.Color:=inactiveColor;
end;

procedure TForm1.exitBtnEnter(Sender: TObject);
begin
exitBtn.sStyle.HotStyle.HotPainting.Color:=activeColor;
end;

procedure TForm1.FormDestroy(Sender: TObject);

var
  HTaskbar : HWND;
//  OldVal : LongInt;
  handle : THandle;
//  compteur : integer;
begin
 //Find handle of TASKBAR
   HTaskBar:=FindWindow('Shell_TrayWnd',nil);
//Enable the taskbar
   EnableWindow(HTaskBar,True);
 //Show the taskbar
   ShowWindow(HTaskbar,SW_SHOW);
//   listeCovers.Destroy;
   clearCoversList(false);
   streamlist.Destroy;
//   ShowCursor(True);
   Handle := FindWindow(nil,PChar('myHTPC'));
   If Handle <> 0 Then BringWindowToTop(Handle);
   addLog('myCDRip closing');
   closeLog;
   if myTag <> nil then
      myTag.free;
end;

procedure TForm1.cddbbtnClick(Sender: TObject);
begin
cddb:=false;
refreshCD;
clearCoversList(true);
CDDBQuery;
end;

procedure TForm1.ripbtnMouseEnter(Sender: TObject);
begin
ripBtn.sStyle.HotStyle.HotPainting.Color:=activeColor;
end;

procedure TForm1.ripbtnMouseLeave(Sender: TObject);
begin
ripBtn.sStyle.Painting.Color:=inactiveColor;
end;

procedure TForm1.exitbtnClick(Sender: TObject);
begin
    stopRip:=true;
    close;
end;

procedure TForm1.Timer1Timer(Sender: TObject);
begin
if auto and cddb then
  begin
  CDRip;
  end;
//if form1.Visible=true then cddbbtn.SetFocus;
timer1.Enabled:=false;
end;

procedure TForm1.slideBtnClick(Sender: TObject);
begin
currCover:=currCover+1;
if currCover>streamlist.Count-1 then currCover:=0;
showCover(currCover);
end;

procedure TForm1.CDEvents1AfterRemove(Sender: TObject;
  FirstDriveLetter: Char);
begin
//CDDB1.CdRoms.CdRom[i].Description
  trackList.Items.Clear;
  artist.Text:='';
  album.Text:='';
  category.Text:='';
  clearCoversList(true);
  sPanel3.Caption:='CD Ejected !';
  sPanel3.Repaint;
end;

procedure TForm1.CDEvents1AfterArrival(Sender: TObject;
  FirstDriveLetter: Char);
begin
  sPanel3.Caption:='CD Inserted !';
  sPanel3.Repaint;
  cddbbtnClick(sender);
end;

procedure TForm1.bitrateBoxChange(Sender: TObject);
begin
case audioFormatBox.ItemIndex of
  0 : begin;
      mp3out1.BitRate:=TMP3BitRate(GetEnumValue(TypeInfo(TMP3BitRate),bitratebox.Items[bitratebox.ItemIndex]));
      end;
  1 : begin;
      vorbisout1.Compression:=strtofloat(bitratebox.Items[bitratebox.ItemIndex]);
      end;
  end;
end;

procedure TForm1.FLACOut1ThreadException(Sender: TComponent; E: Exception);
begin
  addLog('FLAC : Thread Exception : '+E.Message);
end;

procedure TForm1.MP3Out1ThreadException(Sender: TComponent; E: Exception);
begin
  addLog('MP3 : Thread Exception : '+E.Message);
end;

procedure TForm1.VorbisOut1ThreadException(Sender: TComponent;
  E: Exception);
begin
  addLog('Ogg Vorbis : Thread Exception : '+E.Message);
end;

end.
